-- MySQL Script generated by MySQL Workbench
-- So 12 Jan 2020 20:41:58 CET
-- Model: New Model    Version: 1.0
-- MySQL Workbench Forward Engineering

SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0;
SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0;
SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='TRADITIONAL,ALLOW_INVALID_DATES';

-- -----------------------------------------------------
-- Schema testdb
-- -----------------------------------------------------

-- -----------------------------------------------------
-- Schema testdb
-- -----------------------------------------------------
CREATE SCHEMA IF NOT EXISTS `testdb` DEFAULT CHARACTER SET utf8 ;
USE `testdb` ;

-- -----------------------------------------------------
-- Table `testdb`.`suppliers`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `testdb`.`suppliers` (
  `idsupplier` INT UNSIGNED NOT NULL AUTO_INCREMENT,
  `name` VARCHAR(200) NOT NULL,
  PRIMARY KEY (`idsupplier`))
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `testdb`.`projects`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `testdb`.`projects` (
  `idproject` INT UNSIGNED NOT NULL AUTO_INCREMENT,
  `name` VARCHAR(200) NOT NULL,
  `comment` VARCHAR(200) NULL,
  `project_state` ENUM('running', 'finished') NOT NULL,
  `date_started` DATE NOT NULL,
  `date_finished` DATE NULL,
  PRIMARY KEY (`idproject`))
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `testdb`.`users`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `testdb`.`users` (
  `iduser` INT UNSIGNED NOT NULL AUTO_INCREMENT,
  `username` VARCHAR(50) NOT NULL,
  `firstname` VARCHAR(100) NULL,
  `lastname` VARCHAR(100) NULL,
  `credential_hash` VARCHAR(200) NULL,
  `authentication_level` INT NOT NULL,
  `state` ENUM('active', 'inactive') NOT NULL,
  PRIMARY KEY (`iduser`))
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `testdb`.`orderings`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `testdb`.`orderings` (
  `idordering` INT UNSIGNED NOT NULL AUTO_INCREMENT,
  `order_nameid` VARCHAR(100) NOT NULL,
  `idsupplier` INT UNSIGNED NOT NULL,
  `material` VARCHAR(100) NULL,
  `idproject` INT UNSIGNED NOT NULL,
  `idemployee_ordered` INT UNSIGNED NOT NULL,
  `order_state` ENUM('ordered', 'confirmed', 'delivered', 'invoiced') NOT NULL,
  `date_ordered` DATE NULL,
  `date_invoice_planned` DATE NOT NULL,
  `date_planned` DATE NULL,
  `date_delivered` DATE NULL,
  `date_invoiced_done` DATE NULL,
  `invoice` DECIMAL(8,2) NOT NULL,
  `comment` VARCHAR(200) NULL,
  PRIMARY KEY (`idordering`),
  INDEX `fk_orderings_supplier_idx` (`idsupplier` ASC),
  INDEX `fk_orderings_project_idx` (`idproject` ASC),
  INDEX `fk_orderings_employee_idx` (`idemployee_ordered` ASC),
  CONSTRAINT `fk_orderings_suppliers`
    FOREIGN KEY (`idsupplier`)
    REFERENCES `testdb`.`suppliers` (`idsupplier`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION,
  CONSTRAINT `fk_orderings_employees`
    FOREIGN KEY (`idemployee_ordered`)
    REFERENCES `testdb`.`users` (`iduser`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION,
  CONSTRAINT `fk_orderings_projects`
    FOREIGN KEY (`idproject`)
    REFERENCES `testdb`.`projects` (`idproject`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION)
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `testdb`.`documents`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `testdb`.`documents` (
  `iddocument` INT UNSIGNED NOT NULL AUTO_INCREMENT,
  `name` VARCHAR(100) NOT NULL,
  `filename` VARCHAR(1000) NOT NULL,
  `type` ENUM('undefined', 'order', 'orderconfirmation', 'delivery', 'invoice') NOT NULL,
  `filedate` DATE NOT NULL,
  `idemployee_added` INT UNSIGNED NOT NULL,
  `idordering` INT UNSIGNED NOT NULL,
  `comment` VARCHAR(200) NULL,
  `state` ENUM('unassigned', 'assigned', 'inactive', 'deleted') NULL,
  PRIMARY KEY (`iddocument`),
  INDEX `fk_documents_1_idx` (`idemployee_added` ASC),
  INDEX `fk_documents_3_idx` (`idordering` ASC),
  CONSTRAINT `fk_documents_1`
    FOREIGN KEY (`idemployee_added`)
    REFERENCES `testdb`.`users` (`iduser`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION,
  CONSTRAINT `fk_documents_3`
    FOREIGN KEY (`idordering`)
    REFERENCES `testdb`.`orderings` (`idordering`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION)
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `testdb`.`config`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `testdb`.`config` (
  `idconfig` INT UNSIGNED NOT NULL,
  `key` VARCHAR(100) NOT NULL,
  `value` VARCHAR(500) NULL,
  PRIMARY KEY (`idconfig`))
ENGINE = InnoDB;


SET SQL_MODE=@OLD_SQL_MODE;
SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS;
SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS;
