-- MySQL Script generated by MySQL Workbench
-- So 12 Jan 2020 20:41:58 CET
-- Model: New Model    Version: 1.0
-- MySQL Workbench Forward Engineering


-- -----------------------------------------------------
-- Schema testdb
-- -----------------------------------------------------

-- -----------------------------------------------------
-- Schema testdb
-- -----------------------------------------------------

-- -----------------------------------------------------
-- Table `suppliers`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `suppliers` (
  `idsupplier` INTEGER PRIMARY KEY,
  `name` VARCHAR(200) NOT NULL)
;


-- -----------------------------------------------------
-- Table `projects`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `projects` (
  `idproject` INTEGER PRIMARY KEY,
  `name` VARCHAR(200) NOT NULL,
  `comment` VARCHAR(200) NULL,
  `project_state` VARCHAR NOT NULL,
  `date_started` DATE NOT NULL,
  `date_finished` DATE NULL)
;


-- -----------------------------------------------------
-- Table `users`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `users` (
  `iduser` INTEGER PRIMARY KEY,
  `username` VARCHAR(50) NOT NULL,
  `firstname` VARCHAR(100) NULL,
  `lastname` VARCHAR(100) NULL,
  `credential_hash` VARCHAR(200) NULL,
  `authentication_level` INT NOT NULL,
  `state` VARCHAR NOT NULL)
;


-- -----------------------------------------------------
-- Table `orderings`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `orderings` (
  `idordering` INTEGER PRIMARY KEY,
  `order_nameid` VARCHAR(100) NOT NULL,
  `idsupplier` INT UNSIGNED NOT NULL,
  `material` VARCHAR(100) NULL,
  `idproject` INT UNSIGNED NOT NULL,
  `idemployee_ordered` INT UNSIGNED NOT NULL,
  `order_state` VARCHAR NOT NULL,
  `date_ordered` DATE NULL,
  `date_invoice_planned` DATE NOT NULL,
  `date_planned` DATE NULL,
  `date_delivered` DATE NULL,
  `date_invoiced_done` DATE NULL,
  `invoice` DECIMAL(8,2) NOT NULL,
  `comment` VARCHAR(200) NULL,
  CONSTRAINT `fk_orderings_suppliers`
    FOREIGN KEY (`idsupplier`)
    REFERENCES `suppliers` (`idsupplier`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION,
  CONSTRAINT `fk_orderings_employees`
    FOREIGN KEY (`idemployee_ordered`)
    REFERENCES `users` (`iduser`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION,
  CONSTRAINT `fk_orderings_projects`
    FOREIGN KEY (`idproject`)
    REFERENCES `projects` (`idproject`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION)
;


-- -----------------------------------------------------
-- Table `documents`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `documents` (
  `iddocument` INTEGER PRIMARY KEY,
  `name` VARCHAR(100) NOT NULL,
  `filename` VARCHAR(1000) NOT NULL,
  `type` VARCHAR NOT NULL,
  `filedate` DATE NOT NULL,
  `idemployee_added` INT UNSIGNED NOT NULL,
  `idordering` INT UNSIGNED NOT NULL,
  `comment` VARCHAR(200) NULL,
  `state` VARCHAR NULL,
  CONSTRAINT `fk_documents_1`
    FOREIGN KEY (`idemployee_added`)
    REFERENCES `users` (`iduser`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION,
  CONSTRAINT `fk_documents_3`
    FOREIGN KEY (`idordering`)
    REFERENCES `orderings` (`idordering`)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION)
;


-- -----------------------------------------------------
-- Table `config`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `config` (
  `idconfig` INT UNSIGNED NOT NULL,
  `key` VARCHAR(100) NOT NULL,
  `value` VARCHAR(500) NULL)
;


